package net.hoopajoo.cheeselab3;
import java.sql.*;
import java.util.*;
import java.io.*;

public class CheeseProxy {
	static Properties props = null;

	// This replaces the semaphore
	static private long syncid = 0;	
	static private long tiles_syncid = 0;
	static private long world_syncid = 0;
	
	public static void tiles_changed() {
		tiles_syncid++;
	}
	
	public static void world_changed() {
		world_syncid++;
	}
	
	public static void changed() {
		CheeseLab.dmesg( 2, "Increment changed" );
		syncid++;
	}
	
	public static long get_syncid() {
		return( syncid );
	}
	
	public static long get_tiles_syncid() {
		return( tiles_syncid );
	}
	
	public static long get_world_syncid() {
		return( world_syncid );
	}
	
	public static void main(String[] args) {
		// Load properties
		try {
			props = new Properties();
		    FileInputStream in = new FileInputStream( "cheeseproxy.cfg" );
		    props.load( in );
		    //props.list( System.out );
		    in.close();
		    
		}catch( Exception e ) {
			e.printStackTrace();
		}

		try {
			int loglevel = Integer.parseInt( props.getProperty( "loglevel" ) );
			CheeseLab.log_level = loglevel;
		}catch( Exception e ) {
			CheeseLab.log_level = 0;
		}
		
		try {
			// load driver
			Class.forName( "org.apache.derby.jdbc.EmbeddedDriver" );
			
			// Clear users
			CheeseLab.dmesg( 1, "Clearing user online flags and future paths..." );
			Connection db = DriverManager.getConnection( "jdbc:derby:cheesedb" );
			PreparedStatement s = db.prepareStatement( "update user_t set online=0, future=''" );
			s.executeUpdate();
			s.close();
			
			// Leave the db open, so it's loaded in memory for connections
			//db.close();
		}catch( Exception e ) {
			e.printStackTrace();
			return;
		}
		
		// Create server and player sockets
		PlayerServer ps = new PlayerServer();
		ps.start();
		BrokerServer bs = new BrokerServer();
		bs.start();
	}
}
